seo:
  title: AI搭載のGitLab Duoチャットを使用するためのベストプラクティス【10選】 (1)
  description: >-
    AI搭載のDevSecOpsワークフローにGitLab
    Duoチャットを統合するためのヒントとコツをご覧ください。さらに、最高の結果を得るためにチャットプロンプトを絞り込む方法に関する専門家のアドバイスもご紹介します。
  ogTitle: AI搭載のGitLab Duoチャットを使用するためのベストプラクティス【10選】 (1)
  ogDescription: >-
    AI搭載のDevSecOpsワークフローにGitLab
    Duoチャットを統合するためのヒントとコツをご覧ください。さらに、最高の結果を得るためにチャットプロンプトを絞り込む方法に関する専門家のアドバイスもご紹介します。
  noIndex: false
  ogImage: images/blog/hero-images/AdobeStock_479904468-(1).jpeg
  ogUrl: >-
    https://about.gitlab.com/blog/develop-c-unit-testing-with-catch2-junit-and-gitlab-ci
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: >-
    https://about.gitlab.com/blog/develop-c-unit-testing-with-catch2-junit-and-gitlab-ci
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "AI搭載のGitLab Duoチャットを使用するためのベストプラクティス【10選】 (1)",
            "author": [{"@type":"Person","name":"Fatima Sarah Khalid"}],
            "datePublished": "2024-07-02",
          }

content:
  title: AI搭載のGitLab Duoチャットを使用するためのベストプラクティス【10選】 (1)
  description: >-
    AI搭載のDevSecOpsワークフローにGitLab
    Duoチャットを統合するためのヒントとコツをご覧ください。さらに、最高の結果を得るためにチャットプロンプトを絞り込む方法に関する専門家のアドバイスもご紹介します。
  authors:
    - Fatima Sarah Khalid
  heroImage: images/blog/hero-images/AdobeStock_479904468-(1).jpeg
  date: '2024-07-02'
  body: >
    AIと会話を交わすのはチャレンジングかもしれません。どのような質問から始めるべきでしょうか？どのように質問を組み立てますか？どのくらいのコンテキストが必要でしょうか？会話により最高かつ最適な結果を得られるのでしょうか？


    このチュートリアルでは、AI搭載のDevSecOpsワークフローにGitLab
    Duoチャットを統合し、最良な結果を得るためにプロンプトを洗練させる上で役立つヒントとベストプラクティス10選をご紹介します。


    [始める：GitLab
    Duoチャットを開いたままにしておく](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#始める：GitLab-Duoチャットを開いたままにしておく)


    [GitLab
    Duoチャットを使用するためのベストプラクティス10選](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#GitLab-Duoチャットを使用するためのベストプラクティス10選)


    1.
    [会話を交わす](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#1.-会話を交わす)

    2.
    [効率を上げるためにプロンプトを絞り込む](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#2.-効率を上げるためにプロンプトを絞り込む)

    3.
    [プロンプトのパターンに従う](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#3.-プロンプトのパターンに従う)

    4.
    [ローコンテキストコミュニケーションを使用する](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#4.-ローコンテキストコミュニケーションを使用する)

    5.
    [繰り返す](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#5.-繰り返す)

    6.
    [焦らない](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#6.-焦らない)

    7.
    [リセットして再起動](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#7.-リセットして再起動)

    8.
    [IDEのスラッシュコマンドで効率化](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#8.-IDEのスラッシュコマンドで効率化)

    9.
    [スラッシュコマンドのプロンプトを絞り込む](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#9.-スラッシュコマンドのプロンプトを絞り込む)

    10.
    [スラッシュコマンドでクリエイティブに](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#10.-スラッシュコマンドでクリエイティブに)


    ボーナスコンテンツ：

    -
    [ショートカット](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#ショートカット)

    -
    [試してみよう](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#試してみよう)

    -
    [詳細](https://about.gitlab.com/ja-jp/blog/2024/04/02/10-best-practices-for-using-ai-powered-gitlab-duo-chat/#詳細)


    > AIで進化する最新のGitlab １７とGitLab Duoを、ライブ中継で観てみませんか？<br>
    [__＞日本時間6月28日のイベントに今すぐ登録する＜__](https://about.gitlab.com/seventeen/)


    ## 始める：GitLab Duoチャットを開いたままにしておく


    [GitLab
    Duoチャット](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html)は、GitLab
    UI、Web IDE、およびVS CodeなどのサポートされているプログラミングIDEで利用できます。


    VS Codeでは、デフォルトの左ペインでGitLab
    Duoチャットを開くことができます。アイコンを右側のペインにドラッグアンドドロップすることもできます。これにより、コードを書いたり、ファイルツリーを移動したり、Gitアクションを実行したりしている間も、チャットを開いたままにしておくことが可能です。チャットの場所をリセットするには、コマンドパレットを開きます。macOSの場合は
    `[Command] + [Shift] + [P]`、Windows/Linuxの場合は `[Ctrl] + [Shift] + [P]`
    キーボードショートカットを押し、`View: Reset View Locations` と入力します。以下の短いビデオで、その方法を説明します。


    <!-- 空白行 -->

    <figure class="video_container">
      <iframe src="https://www.youtube.com/embed/foZpUvWPRJQ" frameborder="0" allowfullscreen="true"> </iframe>
    </figure>

    <!-- 空白行 -->


    Web IDEとVS Codeは同じフレームワークを共有しています。Web IDEでは同じメソッドを使用でき、より効率的なワークフローを実現できます。


    ![Web
    IDEのチャット](//images.ctfassets.net/r9o86ar0p03f/3g2laogkDFcgDFdvznBKSK/457b2579f799c9610750a5561ccd35d6/image1.png)


    ## GitLab Duoチャットを使用するためのベストプラクティス10選


    ### 1. 会話を交わす


    チャットは会話形式で行うべきであり、検索フォームではありません。


    会話の始め方としては、ブラウザでの検索と同様の検索用語から始めて、応答と出力を試してみることをおすすめします。この例では、C#プロジェクトとベストプラクティスから始めましょう。


    > c# start project best practices 

    > 

    > （c#プロジェクト スタート時のベストプラクティス）


    ![C#スタートプロジェクトのベストプラクティスのチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/i490Yk1uv5ykAcZd31u1z/9a490630eef22e8c76b9dd4e8c4f7686/image11.png)


    この回答は、C#の幅広いスコープを理解するのには役立ちますが、すぐに実践できるベストプラクティスを提示しているわけではありません。次は、同じコンテキストで、より焦点を絞った質問をしてみましょう。


    > Please show the project structure for the C# project.

    > 

    > （C#プロジェクトのプロジェクト構造を示してください）


    ![C#プロジェクトの構造のチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/2YkqiNsRk4ZlXzQ7HFMZQk/e086dfe5c35c0de9ebb0c8f880da1e01/image9.png)


    この回答は参考になります。次に、同じ質問の構成でGitに関する質問をしてみましょう。何かを表示してほしいと指示します。


    > Show an example for a .gitignore for C#

    > 

    > （C#の.gitignoreの例を示してください）


    ![C#の.gitignoreのチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/1PuAowm5O4PTUe98UA43vY/e0b063001ffad64d192110144f250d97/image25.png)


    CI/CDに進み、C#プロジェクトを構築する方法を尋ねます。


    > Show a GitLab CI/CD configuration for building the C# project

    > 

    > （C#プロジェクトを構築するためのGitLab CI/CD設定を表示してください）


    ![C#プロジェクトを構築するためのGitLab
    CI/CD設定のチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/7ghHitWNJ8FHmGI53FvAa8/c76156f14ab8d57fa629fecada878026/image16.png)


    この例では、チャットは、具体的な変更をリクエストするよう促しています。.NET SDK 6.0の代わりに、.NET SDK
    8.0を使用するようリクエストしましょう。


    > In the above example, please use the .NET SDK 8.0 image<br>

    > （上記の例では、次を使用してください。.NET SDK 8.0イメージ）


    ![.NET SDK
    8.0を使用するためのチャットプロンプトと回答](//images.ctfassets.net/r9o86ar0p03f/1SpfMN3PslKMCIVyEc0SJh/324b426aaea4a5ee6a11f462979ddec3/image32.png)


    CI/CD設定で.NETコマンドラインインターフェース（CLI）が使用されます。もしかしたら、プロジェクトやテストの構造を作成するコマンドの効率化にも使えるかもしれません。


    > Explain how to create projects and test structure on the CL

    > 

    > （CLIでプロジェクトとテスト構造を作成する方法を説明してください）


    ![CLIでプロジェクトとテスト構造を作成する方法を説明するよう指示するチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/343UrD8PCho5AFRYDR5UVH/eb8f8279cb27830d48941b3e7ecdac48/image14.png)


    もちろん、これらのコマンドをターミナルで実行することもできますが、引き続きVS
    Codeを使用したい場合はどうすればよいでしょうか。チャットに尋ねましょう。


    > Explain how to open a new terminal in VS Code

    > 

    > （VS Codeで新しいターミナルを開く方法を説明してください）


    ![VS
    Codeで新しいターミナルを開く方法を説明するよう指示するチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/67rZkRixE8BOdenC2jwDxF/aaf68e416a0721d416f1372d876e9943/image5.png)


    ### 2. 効率を上げるためにプロンプトを絞り込む


    GitLab Duoチャットを人間と同じように考え、あなたの考えや質問に関してできるだけ多くの文脈を伝えられるよう、文章でやり取りしてください。


    ブラウザで頻繁に検索する方は、クエリに対するこのアプローチをご存知かもしれません。質問を組み立て、さらに用語を追加して範囲を絞り込み、たくさんのタブが表示された上で検索を再開します。 


    ブラウザ検索では、おそらく4つから5つの検索ウィンドウが表示されるでしょう。


    ```マークダウン

    c# start project best practices

    c# .gitignore

    c# gitlab cicd 

    c# gitlab security scanning 

    c# solutions and projects, application and tests

    ``` 


    チャットでの会話でも、同じ戦略を採用できます。より多くの文脈を加え、会話的なアプローチにする必要があります。GitLab
    Duoチャットでは、1回の会話リクエストで複数の質問ができます。例：上記の検索と同様、新しいC#プロジェクトから始めて、ベストプラクティスを適用し、`.gitignore`
    ファイルを追加し、CI/CDとセキュリティスキャンを設定する必要があります。チャットでは、質問を1つのリクエストにまとめることができます。


    > How can I get started creating an empty C# console application in VS Code?
    Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#,
    and add security scanning for GitLab. Explain how solutions and projects in
    C# work, and how to add a test project on the CLI.

    > 

    > （VS
    Codeで空のC#コンソールアプリケーションを作成するにはどうすればよいですか？.gitignoreと.gitlab-ci.ymlの設定をC#用のステップで表示し、GitLabのセキュリティスキャンを追加してください。C#のソリューションとプロジェクトがどのように動作するのかに加え、CLIでテストプロジェクトを追加する方法を説明してください）


    ![より多くの文脈を加えたチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/2ndEBUzzu54As2iVP9gIez/6b9e681f1f05d8a5b1107acad3582332/image37.png)


    この応答で、チャットは会話のフォローアップの質問で具体的な設定例を尋ねるよう提案しています。応用：フォローアップの質問を作成しましょう。同じチャットセッションでは、コンテキストとしてC#を省略することができます。


    > Please show an example for a .gitignore. Please show a CI/CD
    configuration. Include the SAST template.

    > 

    >   （gitignoreの例を示してください。CI/CDの設定を示してください。SASTテンプレートを含めてください）


    ### 3. プロンプトのパターンに従う 


    「プロンプト命令文、助けを求めて、追加のリクエストをする」というパターンに従ってください。最初の質問ですべての答えが得られるとは限りません。閉塞感を感じないよう、最初は「プロンプト命令文、助けを求める」を繰り返すことから始めましょう。


    > I need to fulfill compliance requirements. How can I get started with
    Codeowners and approval rules?

    > 

    > （コンプライアンス要件を満たす必要があります。CODEOWNERSと承認ルールの使い始め方を教えてください）


    ![CODEOWNERSと承認ルールを使い始めるためのチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/6PvMtBxgHTg1mVvmoK2wzm/701d9809a51c9b261ead5adbe309d97a/image19.png)


    回答は役に立つものの、明らかに一般的な内容です。そこで、チーム用の設定について具体的な内容を教えてもらうこともできます。


    > Please show an example for Codeowners with different teams: backend,
    frontend, release managers.

    > 

    > (バックエンド、フロントエンド、リリースマネージャーといった異なるチームのCODEOWNERSの例を示してください)


    ![バックエンド、フロントエンド、リリースマネージャーといった異なるチームのCODEOWNERSの例を示すよう指示するチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/6meZplniPOhV7bi7ZhEWLb/55ece7f9d9b64034132bfb57975d6078/image31.png)


    もう1つの方法は、自分が置かれている状況を説明し、意見を求めることです。STARモデル（状況、タスク、アクション、結果）に従うと、うまく質問ができるでしょう。


    > I have a Kubernetes cluster integrated in GitLab. Please generate a Yaml
    configuration for a Kubernetes service deployment. Explain how GitOps works
    as a second step. How to verify the results?

    > 

    >
    （GitLabに統合されたKubernetesクラスターがあります。KubernetesサービスをデプロイするためのYAML設定を生成してください。2つ目のステップとしてGitOpsがどのように動作するかを説明してください。結果を検証する方法は？）


    ![複数の質問を含むチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/5WsLzp1xFbcExTGfqOLCRe/ec71bacc9b62f4041edcbb9bb08a6348/image27.png)


    ### 4. ローコンテキストコミュニケーションを使用する


    回答するためになるべく多くのコンテキストを提供します。以前の履歴または開かれたソースコードからは、そういった有用なコンテキストが得られない場合もあります。より効率的に質問するために、GitLabのオールリモート環境でのコミュニケーションで使用される[ローコンテキストコミュニケーション](https://handbook.gitlab.com/handbook/company/culture/all-remote/effective-communication/#understanding-low-context-communication)のパターンを適用します。


    次の質問の場合、C++プロジェクトにおいて十分なコンテキストを提供できていません。


    > Should I use virtual override instead of just override?

    > 

    > （単にオーバーライドをつかうのではなく、仮想オーバーライドをつかったほうがいいですか？）


    ![ユーザーが上書きの代わりに仮想の上書きを使用する必要があるかどうかを尋ねるチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/1LYlvCeyAurCDj8jQsPbfb/3103c2c9243ddd40f13ab29f9738d918/image34.png)


    代わりに、より多くのコンテキストを追加してみてください。


    > When implementing a pure virtual function in an inherited class, should I
    use virtual function override, or just function override? Context is C++.

    > 

    >
    （継承クラスに純粋な仮想関数を実装する場合、仮想関数の上書きを使用する必要がありますか、それとも単に関数の上書きを使用する必要がありますか？コンテキストはC++です）


    ![詳細情報を含むチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/5fR29wnHxnuftVGFpMCStQ/399fdc6015980ad002e2052ef7d8ec3c/image36.png)


    この例は、[GitLab
    Duoコーヒーチャット：抽象的なデータベース処理のためにC++関数をOOPクラスにリファクタリングする](https://youtu.be/Z9EJh0J9358?t=2190)でもご紹介しています。


    ### 5. 繰り返す


    AIは予測できないものです。想定した結果が返されない場合や、コンテキストが不足しているためソースコードの例や設定スニペットが生成されない場合があります。質問を繰り返し、要件を絞り込んでいくことをおすすめします。


    以下の例では、C#アプリケーションを作成します。最初の試行では、アプリケーションタイプを指定しませんでした。C#を使用してコンソール/ターミナルだけでなく、UIアプリケーションも作成できます。また、回答結果には、空のサンプルソースコードも表示されませんでした。2つ目に再度入力するプロンプトでは、「コンソール」と「空」の2つの単語を追加します。


    > How can I get started creating an C# application in VSCode?

    > 

    > （VS CodeでC#アプリケーションを作成するにはどうすればよいですか？）

    > 

    > How can I get started creating an empty C# console application in VSCode?

    > 

    > （VS Codeで空のC#コンソールアプリケーションを作成するにはどうすればよいですか？）


    プロンプトの結果は異なります。最初の質問への回答内容は、VS
    Codeウィンドウの手順に従って開始するのに役立ちますが、ソースコードの場所と変更方法は示されません。改良したプロンプトを改めて入力することで、回答内容が修正され、デフォルトのテンプレートを
    「hello world」コードで上書きする方法が示されます。


    ![修正したプロンプトを改めて入力したチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/2N52TAtf5U28SUr3xCAc94/151036ed163b1d8a00ca5c6ae1dd96e9/image28.png)


    質問を繰り返したり洗練させることで、アプリケーションコードやテストの例を表示するよう、チャットにリクエストもできます。


    > How can I get started creating an empty C# console application in VSCode?
    Please show an example for application and tests.

    > 

    > （VS Codeで空のC#コンソールアプリケーションを作成するにはどうすればよいですか？アプリケーションとテストの例を示してください）


    ![アプリケーションとテストの例を求めるチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/6DX8VwKV2mh6jmAOAwqMPy/5e54e2be575eec9244617023d63eca4a/image3.png)


    #### 一般的な質問を繰り返します 


    一般的な技術的質問を尋ねた場合、GitLab
    Duoチャットでは対応できないことがあります。次のシナリオでは、Javaのビルドツールとフレームワークに関する提案を得ようとしたものの、うまくいきませんでした。この質問への答えは数多く考えられます。ビルドツールとしてはMaven、Gradleなどがあり、テクノロジースタックや要件によっては[100以上のJavaフレームワーク](https://en.wikipedia.org/wiki/List_of_Java_frameworks)があります。


    ![Javaのビルドツールとフレームワークに関するチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/1iJc7hO53FF85ODZ3PvTMP/917b11e1f999999c8965473a84836838/image2.png)


    では、[Java Spring
    Boot](https://spring.io/projects/spring-boot)を使った顧客環境に焦点を当てたいと想定してみます。


    > I want to create a Java Spring Boot application. Please explain the
    project structure and show a hello world example.

    > 

    > （JavaのSpring Bootアプリケーションを作りたいです。プロジェクトの構造を説明し、Hello Worldの例を示してください）


    ![Hello
    Worldの例を含め、追加情報を求めるチャットプロンプトと応答](//images.ctfassets.net/r9o86ar0p03f/1Pt5WJw9FO395mxqmregwE/1db7df9367b12a160560252afd701356/image26.png)


    すでに素晴らしい結果が返って来ています。応用として、プロンプトを繰り返し、アプリケーションのデプロイ方法を尋ね、それぞれのステップでさらに改良を加えてください。別の方法として、フォローアップの会話にする方法もあります。


    > I want to create a Java Spring Boot application. Please explain the
    project structure and show a hello world example. Show how to build and
    deploy the application in CI/CD.

    > 

    > （JavaのSpring Bootアプリケーションを作りたいです。プロジェクトの構造を説明し、Hello
    Worldの例を示してください。CI/CDでアプリケーションをビルドおよびデプロイする方法を示してください）

    > 

    > I want to create a Java Spring Boot application. Please explain the
    project structure and show a hello world example. Show how to build and
    deploy the application in CI/CD, using container images.

    > 

    > （JavaのSpring Bootアプリケーションを作りたいです。プロジェクトの構造を説明し、Hello
    Worldの例を示してください。コンテナイメージを使用して、CI/CDでアプリケーションをビルドおよびデプロイする方法を示してください）

    > 

    > I want to create a Java Spring Boot application. Please explain the
    project structure and show a hello world example. Show how to build and
    deploy the application in CI/CD, using container images. Use Kubernetes and
    GitOps in GitLab.

    > 

    > （JavaのSpring Bootアプリケーションを作りたいです。プロジェクトの構造を説明し、Hello
    Worldの例を示してください。コンテナイメージを使用して、CI/CDでアプリケーションをビルドおよびデプロイする方法を示してください。示します。GitLabでKubernetesとGitOpsを使用してください）

    ### 6. 焦らない


    1つの単語または短い文章すると、[このビデオの例に示すように]（https://youtu.be/JketELxLNEw?t=1220）、望ましい結果が得られない場合があります。GitLab
    Duo Chatは、利用可能なデータから推測を行うことができる場合がありますが、より多くのコンテキストの提供を主張する場合もあります。


    例：`labels` はGitLabのドキュメントの内容に一致します。


    ![ラベルと応答に関するチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/1ufVtn5FsVTVmC39DM3deS/4d74ad21f1f54737130ba580ad825d88/image12.png)


    指示内容をブラッシュアップしてイシューボードでの使用法についてさらなる改良を行います。


    > Explain labels in GitLab. Provide an example for efficient usage with
    issue boards.

    > 

    > （GitLabのラベルを説明してください。イシューボードで効率的に使用できる例をください）


    ![例と回答を求めるチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/4PMYNg3t8jpKfXXFvy0gZH/33b634015ecb9575e31f07db9adc7b4f/image21.png)


    または、問題を記述し、その後に質問をして、追加の例を尋ねます。


    > I don't know how to use labels in GitLab. Please provide examples, and how
    to use them for filters in different views. Explain these views with
    examples.

    > 

    >
    （GitLabでラベルを使用する方法が分かりません。さまざまなビューのフィルターにラベルを使用する方法の例をください。これらのビューを例で説明してください）


    ![問題文と回答を含むチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/2daZluJpFkeffkzllQmUBP/93e88f755d5722a7e0f83e0e211a851b/image10.png)


    また、「はい/いいえ」の質問を避け、代わりに特定のコンテキストを追加します。


    > Can you help me fix performance regressions?

    > 

    > （パフォーマンスのレグレッションを修正するのを手伝ってもらえますか？）


    ![パフォーマンスのリグレッションと応答を修正するための助けを求めるチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/VSHim2STPr6Nf859GlWuM/33d683962f029505e0a66f39185f6ac2/image18.png)


    代わりに、プログラミング言語、フレームワーク、テクノロジースタック、および環境を含む、パフォーマンスレグレッションのコンテキストを提供します。次の例では、数年前の環境を使用していますが、現在でも十分正確です。


    > My PHP application encounters performance regressions using PHP 5.6 and
    MySQL 5.5. Please explain potential root causes, and how to address them.
    The app is deployed on Linux VMs.

    > 

    > （私のPHPアプリケーションは、PHP 5.6とMySQL
    5.5を使用してパフォーマンスのリグレッションに遭遇しています。潜在的な根本原因とそれらに対処する方法を説明してください。このアプリはLinux
    VMにデプロイされています）


    ![詳細と回答を含むチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/2WSbgJuRzHorMVKPJMuurf/1e24876aae6debafddea189ca6164c86/image24.png)


    ### 7. リセットして再起動


    時々、チャット履歴を見る限り、意図しない学習経路を辿ってしまったが故に、フォローアップの質問のコンテキストが間違っている場合があります。または、GitLab
    Duoチャットが回答を提供できない特定の質問をした可能性があります。生成系AIは予測不可能であり、特定の例を提供することができなかったかもしれませんが、将来の応答でそれらを提供していけるようになるでしょう（チャットベータで観察）。基礎となる大規模言語モデル（LLM）は、時には無限ループに陥ってしまう場合もあります。


    > How can I get started creating an empty C# console application in VSCode?
    Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#,
    and add security scanning for GitLab. Explain how solutions and projects in
    C# work, and how to add a test project on the CLI.

    > 

    >
    （VSCodeで空のC#コンソールアプリケーションを作成するにはどうすればよいですか？.gitignoreと.gitlab-ci.ymlの設定をC#用のステップで表示し、GitLabのセキュリティスキャンを追加してください。C#のソリューションとプロジェクトがどのように機能するのか、CLIでテストプロジェクトを追加する方法を説明してください）


    上記の内容で質問をした後、よりカスタマイズされた応答を得るために、質問の範囲を縮小したいと思いました。チャットはコンテキストでチャット履歴を把握しており、以前の回答を参照しているため、期待どおりに機能しませんでした。


    > How can I get started creating an empty C# console application in VSCode?
    Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#.

    > 

    >
    （VSCodeで空のC#コンソールアプリケーションを作成するにはどうすればよいですか？.gitignoreと.gitlab-ci.ymlの設定をC#用のステップで表示してください）


    ![設定例と応答を求めるチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/c7ExMo8DMLs2QGolIPd6C/504da2be7cbe64fa01a03b6cb00c7c3b/image23.png)


    チャットを新しいコンテキストに強制的に追加するには、`/reset` をスラッシュ（/）
    コマンドとして使用してセッションをリセットし、質問を繰り返してより良い結果を得ていくことになります。`/clean` または `/clear`
    を使用して、会話内のすべてのメッセージを削除することもできます。


    ### 8. IDEのスラッシュコマンドで効率化


    #### コードを説明する


    - 質問：生成されたコードですか？既存のコードですか？従来のコードですか？

    - 回答：[IDEの`/explain`スラッシュ（/）
    コマンド](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#explain-code-in-the-ide)を使用します。

    - 回答2：より焦点を当てた応答でプロンプトを絞り込む。例： `/explain focus on potential shortcomings or
    bugs. （/explain 潜在的な欠点やバグに焦点を当てる）`


    ![/explainスラッシュ（/）
    コマンドのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/1FSWZABjDb1F883ejugHR8/97162cc6474b93127fba18e1f62cda97/gitlab_duo_chat_slash_commands_explain_01.png)


    ![洗練されたプロンプトでチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/1i7z6iSJSktgqLGs8PZFg9/3c81c9421b7be03baec6b8db87547114/image6.png)


    #### コードのリファクタリング


    - 質問：読みづらいコードですか？長いスパゲッティコードですか？テストカバレッジはゼロですか？

    - 回答：[IDEの`/refactor`スラッシュ（/）
    コマンド](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#refactor-code-in-the-ide)を使用します。

    - 回答2 ：よりターゲットを絞ったアクションのプロンプトを絞り込む。例：オブジェクト指向パターン：`/refactor into
    object-oriented classes with methods and attributes`。


    ![/refactor
    slashコマンドのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/5POcJxOiuWiK2ADBcegkgR/4afa2f60a2310941a77416f1865d500e/image35.png)


    ![洗練されたプロンプトでチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/5y9JAzISyaUurgWtohTun9/4418ec6efc1a8a2dd66e5609d14b6e99/image30.png)


    #### テストを生成


    - 質問：テスト可能なコードですが、テストの作成に時間がかかりすぎますか？

    - 回答：[IDEの`/tests`スラッシュ(/)
    コマンド](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#write-tests-in-the-ide)を使用します。

    -
    回答2：特定のテストフレームワーク、またはテストターゲットのプロンプトを絞り込む。プロンプトにリファクタリングに焦点を当てるように指示し、次にテストを生成することもできます。`/tests`はコードを関数にリファクタリングし、テストを生成することに焦点を当てます。


    ![/testsスラッシュ(/)
    コマンドのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/1yhfIQcniJpcocwrYYMRqT/22e2019801e756e8ede9076d5d93ddb5/image29.png)


    ![洗練されたプロンプトでチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/2VBnvwX2No2Rd7Yad7KMxM/22a311c2cf53cf25d26e6390027fb157/image4.png)


    完全な開発ワークフローのより実用的な例は、[GitLab
    Duoの例](https://docs.gitlab.com/ee/user/gitlab_duo_examples.html)のドキュメンテーションで入手できます。


    ### 9. スラッシュコマンドのプロンプトを絞り込む


    このブログ記事には、洗練されたプロンプトのヒントが数多くあったことでしょう。これらは、AIを活用したワークフロー効率を向上させるための要素の1つです。スラッシュ(/)
    コマンドを賢く使うことで、GitLab Duoチャットでより良い結果が得られます。


    あるお客様は最近、次のように尋ねました。「`/explain` を使用したコードの説明は、コード内にコメントを作成できますか？」
    答えは「いいえ」です。ただし、チャットプロンプトを使用してフォローアップの質問をしたり、コード内に記述できるコメント形式でコードの要約を求めることができます。その場合は、言語の指定が必要でしょう。


    [curlライブラリを使用したC++
    HTTPクライアントコード](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5cc9bdd65ee8ee16c548bea0402c18f8209d4d06/chat/slash-commands/c++/cli.cpp)の次の例には、より多くのドキュメント（指示内容）が必要です。コード内のコメントを追加して、より洗練した指示内容を/explainコマンドに渡すことで、よりよい結果が得られ、その結果をエディタ内に貼り付けていく、という方法もよいでしょう。


    > /explain add documentation, rewrite the code snippet

    > （/explain ドキュメントを追加し、コードスニペットを書き換えてください）


    ![ドキュメントを追加し、コードスニペットと応答を書き換えるためのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/7MRtMT1kgIOIh0PewiSSSJ/a40d82c9ca40c43d7c6795d67d7e04ea/image13.png)


    または、チャットにソースコードを `/refactor`
    するように依頼し、洗練されたプロンプトを使用して不足しているコードコメントを生成することもできます。


    > /refactor add code comments and documentation

    >

    > （/refactor コードのコメントとドキュメントを追加してください）


    ![ソースコードをリファクタリングし、コードコメントを生成するためのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/6b9kAr2A27UKdJoTEUru9E/048b6a9f7946c602ade466e2849cb3ea/image15.png)


    ### 10. スラッシュコマンドでクリエイティブに


    チャットプロンプトがソースコードまたはプログラミング言語に関する質問への回答が得られない場合は、スラッシュ(/) コマンド
    `/explain`、`/explain`、`/tests` を試してみて、それらがコンテキスト作りに役に立つかどうかみてみましょう。


    以下の例では、C++のコード内でSQLクエリ文字列が1行で作成されます。読みやすさを高め、将来的にはより多くのデータベース列を追加できるようにするには、書式を複数行の文字列に変更すると便利です。


    > std::string sql = "CREATE TABLE IF NOT EXISTS users （id INTEGER PRIMARY
    KEY AUTOINCREMENT, name TEXT NOT NULL, email TEXT NOT NULL）";


    たとえば、次の質問をその後に続けてGitLab Duo Chatに尋ねられます。


    > How to create a string in C++ using multiple lines?<br>

    >（複数行を使用してC++で文字列を作成する方法）


    チャット自体は、説明文とオプションでソースコードの例で回答してくれるでしょう。ただ、この場合は、単にその文字列を"¥n"を間に入れて複数行にすればいい、という解釈をするでしょう。でも、私達が求めているのは、そうではなく、ソースコード上で見やすくするために「複数行」にしてほしい、ということですよね。


    VSCodeとWeb IDEには、追加のコンテキストの代替案があります。問題のソースコードを選択し、右クリックして、[GitLab Duoチャット]>
    [リファクタリング]に移動します。これにより、チャットプロンプトが開き、`/refactor`コードタスクがすぐに開始されます。


    ただし、コードタスクは期待される結果をもたらさない可能性があります。1行のSQL文字列をリファクタリングすることは、読みやすさのために複数行を使用すること、定数を作成することなど、多くを意味するからです。


    コードタスクには、プロンプトを絞り込むオプションがあります。`/refactor` コマンドの後にテキストを追加し、GitLab
    Duoチャットに特定のコードタイプ、アルゴリズム、またはデザインパターンを使用するように指示できます。


    もう一度やり直してみましょう。ソースコードを選択し、フォーカスをチャットに変更し、次のプロンプトを入力して、`[Enter]`を押します。


    > /refactor into a multi-line written string. Show different approaches for
    all C++ standards.

    >

    >（/refactor 複数行の書き込み文字列に変換します。すべてのC++標準に異なるアプローチを示します）


    ![複数行の文字列と応答にリファクタリングするためのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/A2mhrLSH5N10f0Hw8razk/bb5868f7d178d4da3d2ee2855ec0f4ca/image17.png)


    **ヒント：** GitLab Duoのコード提案を使用して、リファクタリング後にソースコードをさらに洗練することも、あるいは、かわりに
    `/refactor` プロンプトの絞り込みを使用することもできます。


    > /refactor into a multi-line written string, show different approaches

    >

    > （/refactor 複数行の文字列に変換し、さまざまなC++標準のアプローチを表示してください）

    >

    > /refactor into multi-line string, not using raw string literals

    >

    > （/refactor 複数行の文字列に変換し、生の文字列リテラルを使用しないでください）

    >

    >/refactor into a multi-line written string. Make the table name
    parametrizable

    >

    >（/refactor 複数行の書き込み文字列に変換してください。テーブル名はパラメータ化してください）


    `stringstream` タイプの代替アプローチは、[GitLab
    Duoコーヒーチャット：抽象的なデータベース処理のためにC++関数をOOPクラスにリファクタリングする](https://www.youtube.com/watch?v=Z9EJh0J9358)、[MR差分](https://gitlab.com/gitlab-da/use-cases/ai/gitlab-duo-coffee-chat/gitlab-duo-coffee-chat-2024-01-23/-/commit/7ea233138aed46d77e6ce0d930dd8e10560134eb#4ce01e4c84d4b62df8eed159c2db3768ad4ef8bf_33_35)に記載されています。


    #### 脆弱性の説明


    常に機能するとは限りませんが、セキュリティの脆弱性の説明については、`/explain` スラッシュ(/)
    コマンドも尋ねることができます。この例では、[Cコード](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5a5f293dfbfac7222ca4013d8f9ce9b462e4cd3a/chat/slash-commands/c/vuln.c)には、strcpy()バッファオーバーフロー、ワールド書き込み可能なファイルアクセス許可、競合条件攻撃などの複数の脆弱性が含まれています。


    >/explain why this code has multiple vulnerabilitie<br>

    >（/explain このコードに複数の脆弱性がある理由を説明してください）


    ![/コードの複数の脆弱性についてのチャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/5yaB0m0ocrJZj70VREuUk0/525ac7ae7462bfdbeae64ac9fa534dc3/image20.png)


    #### CコードをRustにリファクタリングする


    Rustはメモリの安全性を提供します。`refactor into Rust`
    を使用して、脆弱な[Cコード](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5a5f293dfbfac7222ca4013d8f9ce9b462e4cd3a/chat/slash-commands/c/vuln.c)をRustにリファクタリングするようにDuo
    Chatに依頼できます。より良い結果を得るために、より洗練されたプロンプトで練習してください。


    > /refactor into Rust and use high level libraries

    > 

    > （/refactor Rustに変換し、高レベルのライブラリを使用してください）


    ![チャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/2T7D2Y5F4RxfEjZeMwzFwj/e2015aeff80c0210089d7dc816b7e96a/image8.png)


    ### ショートカット


    これらのショートカットを読者の環境で試し、GitLab Duoチャットを使用して応用例を試してみてください。


    1. CVEからの脆弱性に基づいてコードを調べ、`/explain why is this code vulnerable`
    を使用して、それが何をし、どのように修正するかを尋ねます。

    **ヒント：** GitLab Duoチャットのコード説明を利用するには、GitLabでオープンソースプロジェクトをインポートしてください。

    2. レガシーコードの移行計画を支援するために、コードを新しいプログラミング言語にリファクタリングしてみてください。

    3. `/refactor into GitLab CI/CD configuration` を使用して、Jenkins設定をGitLab
    CI/CDにリファクタリングすることもできます。


    ### 試してみよう


    クリッピーのように振る舞うよう、チャットを説得してみてください。


    ![チャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/7Ina5Pl649a9MkHUOiFDJt/45c7d5e732e004bfae744732f4469d23/image22.png)


    GitLabのミッション、「誰でも貢献できます」について尋ねてください。


    ![チャットプロンプト](//images.ctfassets.net/r9o86ar0p03f/2iTw3UgoIy7Jwo2ogBCJK4/65ea627a37edad89fcc061701a01b359/image33.png)


    ### 詳細


    いろいろなところに情報が記載されています。より実用的な例で[GitLab
    Duoチャットドキュメンテーション](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html)を更新し、チャットを含むAI搭載のDevSecOpsワークフローを深く掘り下げる新しい[GitLab
    Duoの例](https://docs.gitlab.com/ee/user/gitlab_duo_examples.html)セクションを追加しました。


    GitLab Duoの学習は、遊び心のあるチャレンジと実際の本番環境のコードを通じて最も効果的に機能します。新しい学習シリーズ、GitLab
    Duoコーヒーチャットは、2024年も続きます。本人確認ができるまでは、[このYouTubeプレイリスト](https://www.youtube.com/playlist?list=PL05JrBw4t0Kp5uj_JgQiSvHw1jQu0mSVZ)で録画を見ることができます。GitLabのお客様で、GitLab
    Duoコーヒーチャットに参加して一緒に学ぶことに興味がある場合は、[この計画のエピック](https://gitlab.com/groups/gitlab-com/marketing/developer-relations/-/epics/476)でお知らせください。


    *監修：小松原 つかさ<br>

    （GitLab合同会社 ソリューションアーキテクト本部 シニアパートナーソリューションアーキテクト）*


    > GitLab
    Duoチャットを試してみませんか？[今すぐ無料トライアルを開始](https://about.gitlab.com/solutions/gitlab-duo-pro/self-managed-and-gitlab-dedicated-trial/)。
  category: DevSecOps
  tags:
    - tutorial
    - testing
    - CI
    - AI/ML
    - DevSecOps
config:
  slug: develop-c-unit-testing-with-catch2-junit-and-gitlab-ci
  featured: true
  template: BlogPost
